#include<stdio.h>
#include<stdlib.h>
int main(){
    int n,q;
    scanf("%d%d",&n,&q);
    int d[n];
    long long p[n],c[n];
    for(int i=0;i<n;i++){
        scanf("%d%lld",&d[i],&p[i]);
    }
    c[0]=p[0];
    for(int i=1;i<n;i++){
        c[i]=c[i-1]+p[i];
    }
    while(q--){
        long long k,e=0,pd=0;scanf("%lld",&k);
        for(int i=0;i<n;i++){
            if(d[i]>k){
                break;
            }
            long long da=d[i]-pd;
            if(da<=c[i]){
                e+=da;
                c[i]-=da;
            }
            else{
                e+=c[i];
                c[i]=0;
            }
            pd=d[i];
        }
        if(k>d[n-1]){
            e+=(k-d[n-1]<c[n-1]?k-d[n-1]:c[n-1]);
        }
        printf("%lld\n",e);
    }
    return 0;
}